Attribute VB_Name = "Gauss_Ausg"
Option Explicit

Public aTab(0 To 10) As Integer, Tab0 As Integer
Public strZ(0 To 10) As String
Public Pfad As String, strVers1 As String
Public vers1z As Single
Public p As Object

Public Sub SystemAusDatei()
  Dim sfile As String
  Dim i As Integer, j As Integer

  On Error GoTo errorSysAusD
  
  If Len(Pfad) = 0 Then Pfad = App.Path + "\Beispiel\"

  With frm_Gauss.CommonDialog1
    .DialogTitle = "vorh. Gleichungssystem laden"
    .CancelError = False
    .InitDir = Pfad
    .Filter = "Alle Dateien (*.*)|*.*|bisherige Projekte(*.GSS)|*.GSS"
    .FilterIndex = 2
    .ShowOpen
    If Len(.FileName) = 0 Then Exit Sub
    sfile = .FileName
  End With

  Open sfile For Input As #3

  Input #3, strVers1
  vers1z = Val(Mid(strVers1, 4, 3))
  Line Input #3, strProjekt
  Line Input #3, strPosition

  Input #3, N
  For i = 1 To N
    For j = 1 To N
      Input #3, A(i, j)
    Next j
    Input #3, B(i)
  Next i

  Close #3
  Exit Sub

errorSysAusD:
  MsgBox ("Fehler in Sub SystemAusDatei: " + Err.Description)
  Close #3
End Sub    'SystemAusDatei

Sub SystemInDatei()
  Dim sfile As String
  Dim i As Integer, j As Integer

  On Error GoTo errorSysinD
  
  If Len(Pfad) = 0 Then Pfad = App.Path + "\Beispiel\"
  
  With frm_Gauss.CommonDialog1
    .DialogTitle = "Gleichungssystem speichern"
    .CancelError = False
    .InitDir = Pfad
    .Filter = "Alle Dateien (*.*)|*.*|bisherige Projekte(*.GSS)|*.GSS"
    .FilterIndex = 2
    .Flags = cdlOFNOverwritePrompt
    .ShowSave
    If Len(.FileName) = 0 Then Exit Sub
    sfile = .FileName
  End With

  Open sfile For Output As #2

  Print #2, "### Gauss " + strVersion
  Print #2, strProjekt: Print #2, strPosition

  Print #2, Str(N)
  For i = 1 To N
    For j = 1 To N
      Print #2, Str(A(i, j))
    Next j
    Print #2, Str(B(i))
  Next i

  Close #2
  Exit Sub

errorSysinD:
  MsgBox ("Fehler in Sub SystemInDatei: " & Err.Description)
  Close #2
End Sub   'SystemInDatei

Public Sub Drucken()           'Ausgabe auf Drucker
  Dim i As Integer, j As Integer

  With frm_Gauss.CommonDialog1
    .CancelError = False
    On Error GoTo MErrDr_Nachw
    .ShowPrinter
  End With

  Set p = Printer
  With p
    p.ScaleMode = 6              'in mm
    p.FontName = "arial"

    Call Tabulatoren             'Standardtabulatoren
  
    p.FontSize = 15
    p.FontBold = True
    p.CurrentX = Tab0
    p.CurrentY = Tab0
    p.Print "Programm  " + strPgmName + ", Version " + strVersion
    p.Print

    'Eingaben System - - - - - - - - - - - - - - - - - - - - - - - - -
    p.CurrentX = Tab0
    p.FontSize = 15
    p.FontBold = True
    p.Print "Anzahl der Gleichungen N = " + Str(N)
    p.FontBold = False
    p.Print
    If N < 4 Then p.FontSize = 12
    If N = 4 Then p.FontSize = 11
    If N = 5 Then p.FontSize = 10
  
    strZ(0) = ""
    strZ(N - 1) = "Koeffizientenmatrix A"
    aTab(N + 1) = aTab(N + 1) + 8
    aTab(N + 2) = aTab(N + 2) + 16
    strZ(N + 1) = "rechte Seite"
    strZ(N + 2) = "Ergebnisse"
    Call TabZahlDr(N + 2, 1, p)
  
    strZ(0) = "Nr."
    For i = 1 To N
      strZ(i) = Str(i)
    Next i
    strZ(N + 1) = "B"
    strZ(N + 2) = "X"
    Call TabZahlDr(N + 2, 1, p)
  
    For i = 1 To N
      For j = 1 To N
        strZ(0) = Format(i, "#0")
        strZ(j) = Format(A(i, j), "##0.000")
      Next j
      strZ(N + 1) = Format(B(i), "##0.000")
      strZ(N + 2) = Format(X(i), "##0.000")
      Call TabZahlDr(N + 2, 1, p)
    Next i

    p.EndDoc           'Dokument drucken
  End With

  Exit Sub

MErrDr_Nachw:
  MsgBox "Die Ausgabe konnte nicht gedruckt werden.", , "Hinweis"
  Resume Next
End Sub   'Drucken

Public Sub Tabulatoren()
'Standardtabulatoren fr Druckausgaben
  Dim i As Integer

  Tab0 = 20                    'linker Rand 20 mm
  aTab(0) = 30                 '  eingerckter Text
  aTab(1) = 55                 '  eingerckter Text
  aTab(2) = 80                 'Beginn Variable, rechtsbndig
  aTab(3) = 105                'Zahl, rechtsbndig
  aTab(4) = 130                'Zahl, rechtsbndig
  aTab(5) = 155                'Zahl, rechtsbndig
  aTab(6) = 180                'Zahl, rechtsbndig
  aTab(7) = 205                'Zahl, rechtsbndig

  If N = 4 Then
    For i = 0 To 7
      aTab(i) = CInt(aTab(i) / 1.1)
    Next i
  End If
  If N = 5 Then
    For i = 0 To 7
      aTab(i) = CInt(aTab(i) / 1.2)
    Next i
  End If
End Sub

Public Sub FelderBelegen()
Dim i As Integer
With frm_Gauss
  Call FelderLoeschen
  .Text3.Text = Str(N)
  For i = 1 To N
    .Text4(i - 1).Text = Str(A(1, i))
    .Text5(i - 1).Text = Str(A(2, i))
    .Text6(i - 1).Text = Str(A(3, i))
    .Text7(i - 1).Text = Str(A(4, i))
    .Text8(i - 1).Text = Str(A(5, i))
    'rechte Seite
    .Text9(i - 1).Text = Str(B(i))
    'Ergebnisse
    .Text10(i - 1).Text = "X(" + Str(i) + ") = "
  Next i
End With
End Sub

Public Sub Symmetrie()
'Felder unter der Hauptdiagonalen ergnzen
  Dim i As Integer, k As Integer
  For i = 1 To N
    For k = i + 1 To N
      A(k, i) = A(i, k)
    Next k
  Next i
  Call FelderBelegen
End Sub

Public Sub FelderLoeschen()
'Felder lschen
Dim i As Integer
With frm_Gauss
  For i = 0 To N - 1
    .Text4(i).Visible = True        'Zeile A(1,k)
    .Text5(i).Visible = True        'Zeile A(2,k)
    .Text6(i).Visible = True        'Zeile A(3,k)
    .Text7(i).Visible = True        'Zeile A(4,k)
    .Text8(i).Visible = True        'Zeile A(5,k)
    .Text9(i).Visible = True        'Zeile B(k)
    .Text10(i).Visible = True       'Zeile X(k)
    .Text11(i).Visible = True       'Zeile Kontrollen
    
    .Text4(i).Text = ""
    .Text5(i).Text = ""
    .Text6(i).Text = ""
    .Text7(i).Text = ""
    .Text8(i).Text = ""
    .Text9(i).Text = ""
    .Text10(i).Text = ""
    .Text11(i).Text = ""
  Next i

  For i = N To 4
    .Text4(i).Visible = False
    .Text5(i).Visible = False
    .Text6(i).Visible = False
    .Text7(i).Visible = False
    .Text8(i).Visible = False
    .Text9(i).Visible = False
    .Text10(i).Visible = False
    .Text11(i).Visible = False
  Next i
  If N <= 4 Then
    For i = 0 To N - 1
      .Text8(i).Visible = False
    Next i
  End If
  If N <= 3 Then
    For i = 0 To N - 1
      .Text7(i).Visible = False
    Next i
  End If
  If N <= 2 Then
    For i = 0 To N - 1
      .Text6(i).Visible = False
    Next i
  End If
  If N <= 1 Then
    For i = 0 To N - 1
      .Text5(i).Visible = False
    Next i
  End If

End With
End Sub
